-- ******************************************************************
-- ******************************************************************
-- **                         MorgDKP                              **
-- ******************************************************************
-- ******************************************************************
--
--  You can blame most of this code on Morg:) Rest is Fryguy's.
--


local L = AceLibrary("AceLocale-2.2"):new("MorgDKP")
local BC = AceLibrary("Babble-Class-2.2")
local tablet = AceLibrary("Tablet-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local console = AceLibrary("AceConsole-2.0")
local rosterlib = AceLibrary("RosterLib-2.0")
local roster = rosterlib.roster

MorgBid_Version = "2.4"

function MorgDKP:StartQuery(id, link)
	if (not self:ModActive()) then return end
	if (not self:IsRaided()) then return end
	if (not IsRaidOfficer()) and (not IsRaidLeader()) then DEFAULT_CHAT_FRAME:AddMessage("You must be promoted to send queries.") return end
	self:Scan()
	local points = self.db.account.items[id].points or 0
	needquery = self:HasItem(id)
	if not self.queryneeded then DEFAULT_CHAT_FRAME:AddMessage("Either no classes are selected or no members need this item.") return end
	for qname in pairs(needquery) do
		if self.db.account.defaults.bidwar then
			BidWarDone = nil
			points = 0
			SendAddonMessage("MORGBID", "BIDWAR "..id.." "..points.." "..qname.." "..self.db.account.info[qname].points, "RAID")
		else SendAddonMessage("MORGBID", "QUERY "..id.." "..points.." "..qname.." "..self.db.account.info[qname].points, "RAID")
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("MorgBid query sent: "..id.." "..points)
	local t = { }
  	local points
	for qname in pairs(needquery) do
  		qclass = needquery[qname].class 
		points = self.db.account.info[qname].points
		if self.db.account.defaults.relational and not self.db.account.defaults.bidwar then 
			if self.db.account.info[qname].spent == 0 then self.db.account.info[qname].spent = 1 end
			if self.db.account.info[qname].earned == 0 then self.db.account.info[qname].earned = 1 end
			points = string.format("%.2f", (self.db.account.info[qname].earned/self.db.account.info[qname].spent))
		end
  		if self.db.account.defaults.bidwar then points = 0 end
		table.insert(t, {qname, qclass, "PENDING", points})
  	end
  	self.querytooltips[id] = t
	local sName, _, _, _, _, _, _, _, _, _ = GetItemInfo(id)
	local item = "item"..id
	if self.db.account.defaults.bidwar then local hint = L["BidWarBar_Hint"]
	else local hint = L["Bar_Hint"] end
	self:CreateQueryTooltip(id, item, sName, hint)
end

function MorgDKP:MorgBidQuery()
	if (not self:ModActive()) then return end
	if (not self:IsRaided()) then return end
	SendAddonMessage("MORGBID", "CHECK", "RAID")
	self:Scan()
	local t = { }
  for name, data in pairs(roster) do
  	class = data.class 
  	self:PlayerinDB(name, class)
  	points = self.db.account.info[name].points
  	if (class ~= "PET") then table.insert(t, {name, class, "NONE", points}) end
  end
  local title = L["mvquery"]
	local item = "version"
	local hint = L["Bar_Hint_Version"]
	local id = nil
	self.querytooltips[item] = t
  self:CreateQueryTooltip(id, item, title, hint)
end

function MorgDKP:ItemHistory()
	if (not self:ModActive()) then return end
	local t = { }
 	for num, loot in pairs(self.db.account.raidlog.loot) do
  	name = loot.Player
  	local class = "Unknown"
	if self.db.account.raidlog.playerinfo[name] then class = self.db.account.raidlog.playerinfo[name].class end
  	ItemLink = "|c"..loot.Color.."[|Hitem:"..loot.ItemID.."|h"..loot.ItemName.."|h]|r" 
		points = loot.Costs
  	table.insert(t, {ItemLink, class, name, points})
  	end
  	if #t < 1 then DEFAULT_CHAT_FRAME:AddMessage("The item history is empty.") return end
	local zone = "UNKNOWN"
	if self.db.account.raidlog.zone then zone = self.db.account.raidlog.zone end
	local title = L["itemhistory"]..": "..zone
	local item = "history"
	local hint = L["rightclickclose"]
	local id = nil
	self.querytooltips[item] = t
  	self:CreateQueryTooltip(id, item, title, hint)
end

function MorgDKP:CreateQueryTooltip(id, item, title, hint)
	if not tablet:IsRegistered(item) then
		tablet:Register(item,
			'children', function() 
						tablet:SetTitle(title)
						tablet:SetHint(hint)
						self:UpdateQueryTooltip(id, item) 
					end,
			'clickable', true,
			'cantAttach', true,
			'showTitleWhenDetached', true,
		 	'showHintWhenDetached', true,
		 	'hideWhenEmpty', true,
		 	'menu', function() 
		 			tablet:Attach(item)
		 			dewdrop:Close()
					if self.db.account.defaults.bidwar and item ~= "history" and item ~= "version" then 
						BidWarDone = 1
						self:ShowResults(id, item, self.querytooltips[id]) 
					end
		 		   end
		)
	end
	if tablet:IsAttached(item) then tablet:Detach(item) end
end

function MorgDKP:UpdateQueryTooltip(id, item)
	local cat = tablet:AddCategory('columns', 3)
	if id then 
		t = self.querytooltips[id]
		qso = { PENDING = 3, NEED = 3, TAKE = 2, PASS = 1 }
		if self.db.account.defaults.bidwar then qso = { PENDING = 1, NEED = 3, TAKE = 2, PASS = 1 } end
	else t = self.querytooltips[item] 
		qso = { ["2.4"] = 3, ["2.2"] = 2, ["NONE"] = 1 }
	end
	if item ~= "history" then
    	table.sort(t, function(a,b)
    	local ao = qso[a[3]] or 0
    	local bo = qso[b[3]] or 0
    	if ao == bo then
    		if a[4] == b[4] then
    			return a[2]>b[2]
    		else	
    			return a[4]>b[4]
				end
			else
				return ao>bo
			end
		end)
  end
	for i,v in ipairs(t) do
  	if item == "history" then 
  		r,g,b = 0,0,0
  		r2,g2,b2 = BC:GetColor(v[2])
  		r3,g3,b3 = 0,1,0
  	else r,g,b = BC:GetColor(v[2])
  		r3,g3,b3 = MorgDKP.db.account.info[v[1]].raidloot, MorgDKP.db.account.info[v[1]].raidloot and 1, 0
  		if (v[3] == "NONE") or (v[3] == "PENDING") then r2,g2,b2 = 1,1,0
  		elseif (v[3] == "PASS") then r2,g2,b2 = 1,0,0 
  		else r2,g2,b2 = 0,1,0 end
  	end
    local colortog = 0
    if (v[3] == "NONE") or (v[3] == "PASS") or (v[3] == "PENDING") then colortog = 1 end
    cat:AddLine(
         'text', v[1],
        'textR', r,
        'textG', g,
        'textB', b,
        'text2', string.format("%s",v[3]),
       'text2R', r2,
       'text2G', g2,
       'text2B', b2,
        'text3', v[4],
       'text3R', r3,
       'text3G', g3,
       'text3B', b3,
         'func', function() self:ShowResults(id, item, t) end
    )
	end
end 

function MorgDKP:ShowResults(id, item, t)
	if id and self.db.account.defaults.bidwar and not BidWarDone then self:BidWarOutput(id, t) return end
	if id then self:OutputResults(t, id, item) end
	if item == "version" then
		for num , data in ipairs(t) do
			if data[3] == "NONE" or tonumber(data[3]) < tonumber(MorgBid_Version) then SendChatMessage(L["updatemorgbid"], "WHISPER", "COMMON", data[1]) end
		end
	end
end

function MorgDKP:OnAddonMsg(prefix, message, type, sender)
	if (not MODactive) or ( not UnitInRaid("player")) then return end
	if prefix == "MORGBID" then
		--DEFAULT_CHAT_FRAME:AddMessage(message,type,sender)
		local args = {self:Explode(message, " ")}
		if args[1] == "PASS" or args[1] == "TAKE" or args[1] == "NEED" then
			local item = tonumber(args[2])
			--DEFAULT_CHAT_FRAME:AddMessage("From "..sender..": "..args[1])
			if not self.querytooltips[item] then
					--DEFAULT_CHAT_FRAME:AddMessage("No query for "..args[2])
				return
			end
			for i,v in ipairs(self.querytooltips[item]) do
				if v[1] == sender then
					v[3] = args[1]
					if self.db.account.defaults.bidwar and args[1] ~= "PASS" then v[4] = args[3] end
				end
			end
			tablet:Refresh("item"..item)
		elseif args[1] == "REPLY" then
			if not self.querytooltips["version"] then
					DEFAULT_CHAT_FRAME:AddMessage("No version query.")
				return
			end
			for i,v in ipairs(self.querytooltips["version"]) do
				if v[1] == sender then v[3] = args[3] break end
			end
			tablet:Refresh("version")
		end
	end
end


function MorgDKP:OutputResults(dkpresults, dkpitem, tabletname)
	sName, sLink, iQuality, _, iLevel, sType, sSubType, iCount, iLoc, iTexture = GetItemInfo(dkpitem);
	r, g, b, hex = GetItemQualityColor(iQuality)
	itempoints = MorgDKP.db.account.items[dkpitem].points 
	ItemLink = sLink 
	Lootitem = sName
	local spaces = "                                                                                                                                      "
	local numspace = {10, 7, 5, 2, 1}
	Lootwinner = nil
	for i,v in ipairs(dkpresults) do
		if i == 1 then
			if v[3] == "NEED" or v[3] == "TAKE" then 
				Lootwinner = string.upper(string.sub(v[1],1,1))..string.sub(v[1],2,-1)
				if self.db.account.defaults.bidwar then 
					self.db.account.items[dkpitem].points = v[4] 
					itempoints = v[4]
				end
			end
			if ItemLink and itempoints then SendChatMessage("Results for: "..ItemLink.."   DKP= "..itempoints, "RAID") end
		end	
		local message = string.upper(v[1])
		message = message ..string.sub(spaces,1,(45 - self:CalcSpaces(string.upper(v[1]))))..string.upper(v[2])
		message = message ..string.sub(spaces,1,(self:CalcSpaces(string.upper(v[2]))))..string.upper(v[3])
		message = message ..string.sub(spaces,1,(self:CalcSpaces(string.upper(v[3]))))..string.sub(spaces,1,numspace[string.len(v[4])])..v[4].."   DKP"
		SendChatMessage(message , "RAID")	
		if i == 10 then break end
	end
	if (GetNumLootItems()>0) and Lootitem and Lootwinner then
		if MorgDKP.db.account.processloot then
			MorgDKP.db.account.raidlog.lootbuffer = nil
			MorgDKP.db.account.raidlog.lootbuffer = { }
			for li = 1, GetNumLootItems() do
  			local lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(li)
  			MorgDKP.db.account.raidlog.lootbuffer[lootName] = 1
  		end
  		MorgDKP.db.account.processloot = nil
  	end
  			StaticPopup_Show ("MorgLoot", ItemLink, Lootwinner)
	end
end

function MorgDKP:HasItem(id)
	local slots = {
		INVTYPE_HEAD = "Head",
		INVTYPE_NECK = "Neck",
		INVTYPE_SHOULDER = "Shoulder",
		INVTYPE_BODY = "Chest",
		INVTYPE_CHEST = "Chest",
		INVTYPE_WAIST = "Waist",
		INVTYPE_LEGS = "Legs",
		INVTYPE_FEET = "Feet",
		INVTYPE_WRIST = "Wrist",
		INVTYPE_HAND = "Hands",
		INVTYPE_FINGER = "Finger",
		INVTYPE_TRINKET = "Trinket",
		INVTYPE_WEAPON = "Weapon",
		INVTYPE_SHIELD = "Weapon",
		INVTYPE_RANGED = "Ranged",
		INVTYPE_CLOAK = "Back",
		INVTYPE_2HWEAPON = "Weapon",
		INVTYPE_ROBE = "Chest",
		INVTYPE_WEAPONMAINHAND = "Weapon",
		INVTYPE_WEAPONOFFHAND = "Weapon",
		INVTYPE_RANGEDRIGHT = "Ranged"	
	}
	if not self.db.account.items[id] then return end
	local classes = self.db.account.items[id].classes;
	local _, _, _, _, _, _, _, _, iEquipLoc, _ = GetItemInfo(id);
	local slot = slots[iEquipLoc];
	needquery = { }
	self.queryneeded = nil
	for pname, data in pairs(roster) do
		local playerClass = string.upper(string.sub(data.class,1,1))..string.lower(string.sub(data.class,2,-1))
		self:PlayerinDB(pname, playerClass)
		hasitem = nil
		if (classes[playerClass]) then
			if self.db.account.info[pname] then
				if self.db.account.info[pname].items then
					local items = self.db.account.info[pname].items[slot]
					if items then
						for pi,pv in pairs(items) do
							local _, _, itemCode = strfind(pi, "[^:]+:(%d+):")
							itemCode = tonumber(itemCode)
							id = tonumber(id)
							if itemCode == id and (id ~= 19147 or id ~= 19140 or id ~= 17071) then
								hasitem = 1
							end
						end
					end
				end
			end
			if not hasitem then
				needquery[pname] = { }
				needquery[pname].class = playerClass
				self.queryneeded = 1
			end
		end
	end
	return needquery
end

function MorgDKP:CalcSpaces(word)
	local Letters = {["A"] = 3, ["B"] = 3, ["C"] = 3, ["D"] = 4, ["E"] = 3, ["F"] = 3, ["G"] = 3, ["H"] = 4, ["I"] = 1, ["J"] = 1, ["K"] = 4, ["L"] = 1, ["M"] = 5, ["N"] = 4, ["O"] = 4, ["P"] = 3, ["Q"] = 6, ["R"] = 2, ["S"] = 1, ["T"] = 2, ["U"] = 3, ["V"] = 4, ["W"] = 5, ["X"] = 3, ["Y"] = 3, ["Z"] = 3, ["0"] = 3, ["1"] = 3, ["2"] = 3, ["3"] = 3, ["4"] = 3, ["5"] = 3, ["6"] = 3, ["7"] = 3, ["8"] = 3, ["9"] = 3}
	local classcount = {["PALADIN"] = 8, ["WARLOCK"] = 6, ["MAGE"] = 13, ["DRUID"] = 13, ["WARRIOR"] = 7, ["HUNTER"] = 9, ["PRIEST"] = 11, ["ROGUE"] = 11, ["SHAMAN"] = 4, ["NEED"] = 10, ["TAKE"] = 11, ["PASS"] = 11, ["PENDING"] = 2}
	if classcount[word] then return classcount[word] end
	local l = string.len(word)
	local count = 0
	for i = 1, l do
		let = string.sub(word,i,i)
		val = Letters[let]
		count = count + val
	end
	return count
end

function MorgDKP:BidWarOutput(id, dkpresults)
	local spaces = "                                                                                                                                      "
	local numspace = {10, 7, 5, 2, 1}
	Lootwinner = nil
	Maxbid = nil
	for i,v in ipairs(dkpresults) do
		if i == 1 and v[3] == "TAKE" then 
			Maxbid = v[4]
			self.db.account.items[id].points = v[4]
			SendChatMessage("Bids for this round:", "RAID")
		end
		if i == 1 and v[3] ~= "TAKE" then DEFAULT_CHAT_FRAME:AddMessage("No members want the item.  Close the tablet.") return end	
		local message = string.upper(v[1])
		message = message ..string.sub(spaces,1,(45 - self:CalcSpaces(string.upper(v[1]))))..string.upper(v[2])
		message = message ..string.sub(spaces,1,(self:CalcSpaces(string.upper(v[2]))))..string.upper(v[3])
		message = message ..string.sub(spaces,1,(self:CalcSpaces(string.upper(v[3]))))..string.sub(spaces,1,numspace[string.len(v[4])])..v[4].."   DKP"
		SendChatMessage(message , "RAID")	
		if i == 10 then break end
	end
	if Maxbid then
		for i, v in ipairs(dkpresults) do
			if v[3] ~= "PASS" then 
				v[3] = "PENDING"
				SendAddonMessage("MORGBID", "BIDWAR "..id.." "..Maxbid.." "..v[1].." "..self.db.account.info[v[1]].points, "RAID") end
		end
	end
end