-- ******************************************************************
-- ******************************************************************
-- **                         MorgDKP                              **
-- ******************************************************************
-- ******************************************************************
--
--  You can blame all of this code on Morg:) Lots of inspiration taken from CT_Raidtracker though:)
--

local L = AceLibrary("AceLocale-2.2"):new("MorgDKP")
local rosterlib = AceLibrary("RosterLib-2.0")
local roster = rosterlib.roster
local compost = AceLibrary("Compost-2.0")


function MorgDKP:BeginRaid()
	if (not self:ModActive()) or (not self:IsRaided()) then return end
	StartDate = date()
	ZoneName = GetRealZoneText()
	local zones = L["MorgTracker_ZoneTriggers"]
	if (not zones[ZoneName] ) then
		DEFAULT_CHAT_FRAME:AddMessage("You must be in the instance before you can begin tracking DKP.") return
	end
	MorgDKP:Scan()
	self.db.account.raidlog = nil
	self.db.account.raidlog = { }
	self.db.account.raidlog.playerinfo = { }
	self.db.account.raidlog.join = { }
	self.db.account.raidlog.leave = { }
	self.db.account.raidlog.bosskills = { }
	self.db.account.raidlog.loot = { }
	self.db.account.raidlog.raidstart = StartDate
	self.db.account.raidlog.zone = ZoneName
	self.db.account.processloot = 1
	local attendees = { }
	local counter = 0
	for name in pairs(roster) do
    tbl = roster[name]
    if (tbl.oldclass ~= "PET") and (tbl.class ~= "PET") then 
    	local raidID = tbl.unitid
    	local _, race = UnitRace(raidID)
    	local level = UnitLevel(raidID)
			local guild = GetGuildInfo(raidID)
			local class = tbl.class
			if(name and name ~= "" and name ~= "UNKNOWN") then
				if (not attendees[name]) then attendees[name] = { } end
				if (class) then attendees[name].class = class end
				if(race) then attendees[name].race = race end
				if(level > 0) then attendees[name].level = level end
				if(guild) then attendees[name].guild = guild end
			end
			self.db.account.raidlog.join[name] = StartDate
			counter = counter + 1
		end
	end
	self.db.account.raidlog.playerinfo = attendees
	DEFAULT_CHAT_FRAME:AddMessage("Added "..tostring(counter).." attendees to raid start.")
	MorgDKP:FormatLink(nil)
end	

function MorgDKP:EndRaid()
	if (not self:ModActive()) then return end
	if (not self.db.account.raidlog.raidstart) then DEFAULT_CHAT_FRAME:AddMessage("No current raid exists.") return end
	EndTime = date()
	self.db.account.raidlog.raidend = EndTime
	counter = 0
	for name in pairs(roster) do
    local tbl = roster[name]
    local raidID = tbl.unitid
    if (tbl.oldclass ~= "PET") and (tbl.class ~= "PET") then 
    	if(name and name ~= "" and name ~= "UNKNOWN") then
				self.db.account.raidlog.leave[name] = EndTime
			end
			counter = counter + 1
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("Removed "..tostring(counter).." raid attendees.")
  MorgDKP:FormatLink(nil)
end

function MorgDKP:FormatLink(skip)
	local link = "<RaidInfo>"
	link = link.."<key>"..self.db.account.raidlog.raidstart.."</key>"
	link = link.."<start>"..self.db.account.raidlog.raidstart.."</start>"
	if self.db.account.raidlog.raidend then link = link.."<end>"..self.db.account.raidlog.raidend.."</end>" end
	link = link.."<zone>"..self.db.account.raidlog.zone.."</zone>"
	link = link.."<note>![CDATA[ - Zone: "..self.db.account.raidlog.zone.."]]</note>"
	link = link.."<PlayerInfos>"
	local index = 1
	for key, _ in pairs(self.db.account.raidlog.playerinfo) do
		link = link.."<key"..index..">"
		link = link.."<name>"..key.."</name>"
		for key2, val2 in pairs(self.db.account.raidlog.playerinfo[key]) do
			link = link.."<"..key2..">"..val2.."</"..key2..">"
		end
		link = link.."</key"..index..">"
		index = index + 1
	end
	link = link.."</PlayerInfos>"
	if (not skip) then
		local index = 1
		link = link.."<BossKills>"
		for key, val in pairs(self.db.account.raidlog.bosskills) do
			link = link.."<key"..index..">"
			link = link.."<name>"..key.."</name>"
			link = link.."<time>"..self.db.account.raidlog.bosskills[key].time.."</time>"
			link = link.."<attendees>"
			for key2, val2 in pairs(self.db.account.raidlog.bosskills[key].attendees) do
				link = link.."<key"..key2..">"
				link = link.."<name>"..val2.."</name>"
				link = link.."</key"..key2..">"
			end
			link = link.."</attendees>"
			link = link.."</key"..index..">"
			index = index + 1
		end
		link = link.."</BossKills>"
	else link = link.."<BossKills></BossKills>" end
	local index = 1
	link = link.."<Join>"
	for key, val in pairs(self.db.account.raidlog.join) do
		link = link.."<key"..index..">"
		link = link.."<player>"..key.."</player>"
		link = link.."<time>"..val.."</time>"
		for key2, val2 in pairs(self.db.account.raidlog.playerinfo[key]) do
			link = link.."<"..key2..">"..val2.."</"..key2..">"
		end
		link = link.."</key"..index..">"
		index = index + 1
	end
	link = link.."</Join>"
	local index = 1
	if self.db.account.raidlog.leave then 
		link = link.."<Leave>"
		for key, val in pairs(self.db.account.raidlog.leave) do
			link = link.."<key"..index..">"
			link = link.."<player>"..key.."</player>"
			link = link.."<time>"..val.."</time>"
			link = link.."</key"..index..">"
			index = index + 1
		end
		link = link.."</Leave>"
	end
	if (not skip) then 
		link = link.."<Loot>"
		for key, val in pairs(self.db.account.raidlog.loot) do
			link = link.."<key"..key..">"
			for key2, val2 in pairs(self.db.account.raidlog.loot[key]) do
				link = link.."<"..key2..">"..val2.."</"..key2..">"
			end
			link = link.."</key"..key..">"
		end
		link = link.."</Loot>"
	else link = link.."<Loot></Loot>" end
	link = link.."</RaidInfo>"
	MorgDKP:OutputLink(link)
end

function MorgDKP:OutputLink(link)
	URLFrameEditBox:SetText(link)
	URLFrameEditBox:HighlightText()
	URLFrame:Show()
end

function MorgDKP:HostileDeath()
	if (not MODactive) or (not UnitInRaid("player")) then return end
	local _, _, mobName = string.find( arg1, L["MORGTRACK_DEATH_HOSTILE"] )
  local killTime    = date()
 	if ( mobName ~= nil ) and ( mobName ~= "Majordomo Executus" ) then
  	local Boss = L["MorgTracker_BossUnitTriggers"][mobName]
  	if Boss and (Boss ~= "IGNORE") then
  		MorgDKP:LogBossKill(killTime, Boss)
  	end
  end
end

function MorgDKP:LogBossKill(killTime,Boss)
	local attendees = { }
	counter = 0
	for name in pairs(roster) do
    if(name and name ~= "" and name ~= "UNKNOWN") then
			local tbl = roster[name]
			if (tbl.class ~= "PET") and (tbl.oldclass ~= "PET") then 
				table.insert(attendees, name)
				counter = counter + 1
			end
		end
	end
	if (not self.db.account.raidlog.bosskills[Boss]) then self.db.account.raidlog.bosskills[Boss] = { } end
	self.db.account.raidlog.bosskills[Boss].time = killTime
  self.db.account.raidlog.bosskills[Boss].attendees = attendees
	self.db.account.raidlog.bosskills[Boss].note = "![CDATA[ - Zone: "..GetRealZoneText().." - Boss: "..Boss.."]]"
	self:CheckLootTable()
	self.db.account.raidlog.lastboss = Boss
	self.db.account.processloot = 1
	DEFAULT_CHAT_FRAME:AddMessage(Boss.." killed at "..killTime.." and "..tostring(counter).." attendees added.")
end

function MorgDKP:HostileYell()
	if (not MODactive) or (not UnitInRaid("player")) then return end
	if ( arg1 == L["MORGTRACKER_MAJORDOMO_YELL"] ) then
  	local killTime = date()
 		local Boss = L["MorgTracker_BossUnitTriggers"]["Majordomo Executus"]
 		MorgDKP:LogBossKill(killTime, Boss)
  end
end

function MorgDKP:ProcessRosterChange(raidtbl)
	if (not MODactive) or (not UnitInRaid("player")) then return end 
	local ttime = date()
	for name in pairs(raidtbl) do
		local tbl = raidtbl[name]
		if not tbl.name then
			if (tbl.oldclass ~= "PET") and (tbl.class ~= "PET") then 
				self.db.account.raidlog.leave[tbl.oldname] = ttime
				DEFAULT_CHAT_FRAME:AddMessage(tbl.oldname.." left the raid at "..ttime)
			end
		elseif not tbl.oldname then
			if (tbl.oldclass ~= "PET") and (tbl.class ~= "PET") then 
				local raidID = tbl.unitid
   				local _, race = UnitRace(raidID)
    			local level = UnitLevel(raidID)
				local guild = GetGuildInfo(raidID)
				if (not self.db.account.raidlog.playerinfo) then self.db.account.raidlog.playerinfo = { } end
				if (not self.db.account.raidlog.playerinfo[name]) then self.db.account.raidlog.playerinfo[name] = { } end
				if (tbl.class) then self.db.account.raidlog.playerinfo[name].class = tbl.class end
				if(race) then self.db.account.raidlog.playerinfo[name].race = race end
				if(level > 0) then self.db.account.raidlog.playerinfo[name].level = level end
				if(guild) then self.db.account.raidlog.playerinfo[name].guild = guild end
				if (not self.db.account.raidlog.join[name]) then self.db.account.raidlog.join[name] = ttime end
				MorgDKP:PlayerinDB(name , tbl.class)
				DEFAULT_CHAT_FRAME:AddMessage(name.." joined the raid at "..ttime)
			end
		end
	end
end

function MorgDKP:SystemEvent()
	if (not MODactive) or (not UnitInRaid("player")) then return end 
	local looter = nil
	_, _, looter = string.find(arg1, L["MORGTRACKER_MASTERLOOT"])
	if (not looter) or (looter == self.db.account.defaults.mlooter) then return end
	self.db.account.defaults.mlooter = looter
end

function MorgDKP:TimeDiff(time1, time2)
	local hours1, hours2, min1, min2, total1, total2
   
   if ( time1 ~= nil ) and ( time2 ~= nil ) then
      local _, _, hours1, min1 = string.find(time1, "%d+:(%d+):(%d+)")
      local _, _, hours2, min2 = string.find(time2, "%d+:(%d+):(%d+)")
      total1 = ( hours1 * 60 ) + min1
      total2 = ( hours2 * 60 ) + min2
      if total1 < 60 then total1 = total1 + 1440 end
      if total2 < 60 then total2 = total2 + 1440 end
      if (total1 - total2) < 8 then return true end
   end
   return nil
end   

function MorgDKP:OutputAttendees()
	if (not self.db.account.raidlog.raidstart) then DEFAULT_CHAT_FRAME:AddMessage("No current raid exists.") return end
	MorgDKP:FormatLink(1)
end

function MorgDKP:ReclaimAll()
	--Update raid list for DE
	compost:Reclaim(MorgDKP.opts.args.deer)
	MorgDKP.opts.args.deer = nil
	MorgDKP.opts.args.deer = compost:Acquire()
	MorgDKP.opts.args.deer.type = "text"
	MorgDKP.opts.args.deer.name = L["denchanter"]
	MorgDKP.opts.args.deer.desc = L["denchanterdesc"]
	MorgDKP.opts.args.deer.get = function() return self.db.account.defaults.disenchanter end
	MorgDKP.opts.args.deer.set = function(v) self.db.account.defaults.disenchanter = v  end
	MorgDKP.opts.args.deer.validate = self.db.account.defaults.raidmembers
	MorgDKP.opts.args.deer.order = 7
	
	--Update raid list for BOE
	compost:Reclaim(MorgDKP.opts.args.boes)
	MorgDKP.opts.args.boes = nil
	MorgDKP.opts.args.boes = compost:Acquire()
	MorgDKP.opts.args.boes.type = "text"
	MorgDKP.opts.args.boes.name = L["giveboe"]
	MorgDKP.opts.args.boes.desc = L["giveboedesc"]
	MorgDKP.opts.args.boes.get = false
	MorgDKP.opts.args.boes.set =  function(text) charstring = text MorgDKP:GiveBOE(myid, mylink) end
	MorgDKP.opts.args.boes.validate = self.db.account.defaults.raidmembers
	MorgDKP.opts.args.boes.order = 9
end

	
function MorgDKP:ReclaimML()
	--Update ML
	compost:Reclaim(MorgDKP.opts.args.mlootdet)
	MorgDKP.opts.args.mlootdet = nil
	MorgDKP.opts.args.mlootdet = compost:Acquire()
	MorgDKP.opts.args.mlootdet.type = "text"
	MorgDKP.opts.args.mlootdet.name = L["mloot"]
	MorgDKP.opts.args.mlootdet.desc = L["mlootdesc"]
	MorgDKP.opts.args.mlootdet.get = function() return self.db.account.defaults.mlooter end
	MorgDKP.opts.args.mlootdet.set =  function(v)  self.db.account.defaults.mlooter = v end
	MorgDKP.opts.args.mlootdet.validate = self.db.account.defaults.raidmembers
	MorgDKP.opts.args.mlootdet.order = 6
end

function MorgDKP:CheckLootTable()
	if not self.db.account.raidlog.lastboss then return end
	local lastBoss = self.db.account.raidlog.lastboss
	for key, _ in pairs(self.db.account.raidlog.loot) do
		if lastBoss == self.db.account.raidlog.loot[key]["Boss"] then return end
	end
	local Zone = GetRealZoneText()
	table.insert(self.db.account.raidlog.loot,
					{
						["ItemName"] = "Nexus Crystal",
						["ItemID"] = "20725:0:0:0",
						["Icon"] = "INV_Enchant_ShardNexusLarge",					
						["Class"] = "Trade Goods",
						["SubClass"] = "Trade Goods",
						["Color"] = "ffa335ee",
						["Count"] = "1",
						["Player"] = UnitName("player"),
						["Costs"] = "0",
						["Time"] = date(),
						["Zone"] = Zone,
						["Boss"] = lastBoss,
						["Note"] = "![CDATA[ - Zone: "..Zone.." - Boss: "..lastBoss.."]]"
					}
				)
end
