-- ******************************************************************
-- ******************************************************************
-- **                         MorgDKP                              **
-- ******************************************************************
-- ******************************************************************
--
--  Sorry Morg is to blame again:)
--

local L = AceLibrary("AceLocale-2.2"):new("MorgDKP")
local BC = AceLibrary("Babble-Class-2.2")

local classes = { [2] = BC["Warrior"], [3] = BC["Hunter"], [4] = BC["Rogue"], [5] = BC["Druid"], [6] = BC["Mage"], [7] = BC["Warlock"], [8] = BC["Priest"]}
local classcolors = {[2] = "|c00"..BC:GetHexColor("Warrior"), [3] = "|c00"..BC:GetHexColor("Hunter"), [4] = "|c00"..BC:GetHexColor("Rogue"), [5] = "|c00"..BC:GetHexColor("Druid"), [6] = "|c00"..BC:GetHexColor("Mage"), [7] = "|c00"..BC:GetHexColor("Warlock"), [8] = "|c00"..BC:GetHexColor("Priest")}
local Quality = {[1] = "|c009d9d9dPoor|r", [2] = "|c00ffffffCommon|r", [3] = "|c001eff00Uncommon|r", [4] = "|c000070ddRare|r", [5] = "|c00a335eeEpic|r", [6] = "|c00ff8000Legendary|r", [7] = "|c00e6cc80Artifact|r"}
local engfaction , locfaction = UnitFactionGroup("player")

if (engfaction == L["horde"]) then 
	classes[1] = BC["Shaman"] 
	classcolors[1] = "|c00"..BC:GetHexColor("Shaman")
else classes[1] = BC["Paladin"]
	classcolors[1] = "|c00"..BC:GetHexColor("Paladin")
end


function MorgDKP:optGetKey(table, value)
	for k,v in pairs(table) do
		if value == v then 
			return k
		end
	end
end



function MorgDKP:DoOptions()
	local db = MorgDKP.db.account
	
	MorgDKP.opts = {
			type = "group",
				args = {
					header = {
						type = "header",
						name = "|c000070dd"..L["morgtitle"].."  |c00a335ee"..MorgDKP_Version,
						icon = "Interface\\GroupFrame\\UI-Group-MasterLooter",
						iconHeight = 15,
						iconWidth = 15,
						order = 1
					}, 
					enable = {
						type = "toggle",
						name = L["enablemod"],
						desc = L["enablemoddesc"],
						get = function()
							return MODactive
						end,
						set = function(v)
							MODactive = v
						end,
						order = 2
					},
					mldemode = {
						type = "toggle",
						name = L["enablemlde"],
						desc = L["enablemldedesc"],
						get = function()
							return MLmode
						end,
						set = function(v)
							MLmode = v
						end,
						order = 3
					},
					morgbidc = {
						type = "execute",
						name = L["morgbidcheck"],
						desc = L["morgbidcheckdesc"],
						func = function() MorgDKP:MorgBidQuery() end,
						order = 5
					},
					dkpfunc = {
						type = "group",
						name = L["dkp"],
						desc = L["dkpdesc"],
						order = 6,
							args = {
								load = {
									type = "text",
									name = L["loaddkp"],
									desc = L["loaddkpdesc"],
									get = function() return db.defaults.raid end,
									set = function(v) 
													db.defaults.raid = v
													MorgDKP:PreMergePoints(v) 
												end,
									validate = db.defaults.raidlist,
    							order = 100								
								},
								startrd = {
									type = "execute",
									name = L["startraid"],
									desc = L["startraiddesc"],
									func = function() MorgDKP:BeginRaid() end,
									order = 101
								},
								endrd = {
									type = "execute",
									name = L["endraid"],
									desc = L["endraiddesc"],
									func = function() MorgDKP:EndRaid() end,
									order = 102
								},
								logqual = {
									type = "text",
									name = L["logquality"],
									desc = L["logqualitydesc"],
									get = function() return Quality[db.defaults.quality+1] end,
									set = function(v) db.defaults.quality = MorgDKP:optGetKey(Quality, v) - 1 end,
									validate = Quality,
									order = 104
								},
								runbonus = {
									type = "execute",
									name = L["rundkp"],
									desc = L["rundkpdesc"],
									func = function() MorgDKP:OutputAttendees() end,
									order = 103
								},
								itemhis = {
									type = "execute",
									name = L["itemhistory"],
									desc = L["itemhistorydesc"],
									func = function() MorgDKP:ItemHistory() end,
									order = 105
								},
								dkpadd = {
									type = "text",
									name = L["adddkp"],
									desc = L["adddkpdesc"],
									usage = "<char>",
									get = false,
									set = function(text) 
													charstring = text
													adding = 1
													MorgDKP:ChangeDKP()
												end,
									order = 106
								},
								dkpsub = {
									type = "text",
									name = L["subdkp"],
									desc = L["subdkpdesc"],
									usage = "<char>",
									get = false,
									set = function(text) 
													charstring =  text
													adding = nil
													MorgDKP:ChangeDKP()
												end,
									order = 107
								},
								raiddb = {
									type = "group",
									name = L["raiddbfunc"],
									desc = L["raiddbfuncdesc"],
									order = 108,
										args = {
											newdb = {
												type = "text",
												name = L["newdb"],
												desc = L["newdbdesc"],
												usage = "<char>",
												get = false,
												set = function(text) 
																charstring =  text
																MorgDKP:AddRaidDatabase(text) 
															end,
												order = 100							
											},
											deldbb = {
												type = "text",
												name = L["deldb"],
												desc = L["deldbdesc"],
												get = function() return db.defaults.raid end,
												set = function(v) 
																MorgDKP:DeleteRaidDatabase(MorgDKP:optGetKey(db.defaults.raidlist, v)) 
															end,
												validate = db.defaults.raidlist,
    										order = 101							
											}
										}
								},
								zsum = {
									type = "toggle",
									name = L["enablezerosum"],
									desc = L["enablezerosumdesc"],
									get = function()
										return db.defaults.zerosum
									end,
									set = function(v)
										db.defaults.zerosum = v
									end,
									order = 110
								},
								reldkp = {
									type = "toggle",
									name = L["enablerelationaldkp"],
									desc = L["enablerelationaldkpdesc"],
									get = function()
										return db.defaults.relational
									end,
									set = function(v)
										db.defaults.relational = v
									end,
									order = 112
								},
								bwar = {
									type = "toggle",
									name = L["enablebidwar"],
									desc = L["enablebidwardesc"],
									get = function()
										return db.defaults.bidwar
									end,
									set = function(v)
										db.defaults.bidwar = v
									end,
									order = 114
								},
							}
					},
					mlootdet = {
						type = "text",
						name = L["mloot"],
						desc = L["mlootdesc"],
						get = function() return self.db.account.defaults.mlooter end,
						set = function(v)  self.db.account.defaults.mlooter = v end,
						validate = self.db.account.defaults.raidmembers,
						order = 6
				  },
					deer = {
						type = "text",
						name = L["denchanter"],
						desc = L["denchanterdesc"],
						get = function() return self.db.account.defaults.disenchanter end,
						set = function(v) self.db.account.defaults.disenchanter = v  end,
						validate = self.db.account.defaults.raidmembers,
						order = 7
				  },
					teinly = {
						type = "text",
						name = L["twinks"],
						desc = L["twinksdesc"],
						usage = "<char>",
						get = false,
						set = function(text) twinkstring = text  self:AddTwink() end,
						order = 8
					},
					boes = { 
						type = "text",
						name = L["giveboe"],
						desc = L["giveboedesc"],
						get = false,
						set = function(text) charstring = text MorgDKP:GiveBOE(myid, mylink) end,
						validate = self.db.account.defaults.raidmembers,
						order = 9
					},
					setpt = {
						type = "text",
						name = L["setitempoints"],
						desc = L["setitempointsdesc"],
						usage = "<char>",
						get = function() return db.items[myid].points end,
						set = function(text) db.items[myid].points = text end,
						order = 10
					},
					qraid = {
						type = "execute",
						name = L["queryraid"],
						desc = L["queryraiddesc"],
						func = function() MorgDKP:StartQuery(myid, mylink) end,
						order = 11
					},
					spacer1 = {
						type = "header",
						order = 20
					},
					class1 = {
						type = "toggle",
						name = classcolors[1]..classes[1],
						desc = classcolors[1]..classes[1],
						get = function() return db.items[myid].classes[classes[1]] end,
						set = function(v) db.items[myid].classes[classes[1]] = v end,
						order = 1000
					},
					class2 = {
						type = "toggle",
						name = classcolors[2]..classes[2],
						desc = classcolors[2]..classes[2],
						get = function() return db.items[myid].classes[classes[2]] end,
						set = function(v) db.items[myid].classes[classes[2]] = v end,
						order = 1001
					},
					class3 = {
						type = "toggle",
						name = classcolors[3]..classes[3],
						desc = classcolors[3]..classes[3],
						get = function() return db.items[myid].classes[classes[3]] end,
						set = function(v) db.items[myid].classes[classes[3]] = v end,
						order = 1002
					},
					class4 = {
						type = "toggle",
						name = classcolors[4]..classes[4],
						desc = classcolors[4]..classes[4],
						get = function() return db.items[myid].classes[classes[4]] end,
						set = function(v) db.items[myid].classes[classes[4]] = v end,
						order = 1003
					},
					class5 = {
						type = "toggle",
						name = classcolors[5]..classes[5],
						desc = classcolors[5]..classes[5],
						get = function() return db.items[myid].classes[classes[5]] end,
						set = function(v) db.items[myid].classes[classes[5]] = v end,
						order = 1004
					},
					class6 = {
						type = "toggle",
						name = classcolors[6]..classes[6],
						desc = classcolors[6]..classes[6],
						get = function() return db.items[myid].classes[classes[6]] end,
						set = function(v) db.items[myid].classes[classes[6]] = v end,
						order = 1005
					},
					class7 = {
						type = "toggle",
						name = classcolors[7]..classes[7],
						desc = classcolors[7]..classes[7],
						get = function() return db.items[myid].classes[classes[7]] end,
						set = function(v) db.items[myid].classes[classes[7]] = v end,
						order = 1006
					},
					class8 = {
						type = "toggle",
						name = classcolors[8]..classes[8],
						desc = classcolors[8]..classes[8],
						get = function() return db.items[myid].classes[classes[8]] end,
						set = function(v) db.items[myid].classes[classes[8]] = v end,
						order = 1007
					}
			}
	}
end









